org.apache.lucene.index

## Class MultiDocValues.MultiSortedSetDocValues

- java.lang.Object
- - org.apache.lucene.search.DocIdSetIterator
  - - org.apache.lucene.index.SortedSetDocValues
    - - org.apache.lucene.index.MultiDocValues.MultiSortedSetDocValues

- Enclosing class:
    MultiDocValues

      public static class MultiDocValues.MultiSortedSetDocValues
      extends SortedSetDocValues

  Implements MultiSortedSetDocValues over n subs, using an OrdinalMap
  NOTE: This API is for internal purposes only and might change in incompatible ways in the next release.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `int[]` | `docStarts` docbase for each leaf: parallel with `values`
    `OrdinalMap` | `mapping` ordinal map mapping ords from `values` to global ord space
    `SortedSetDocValues[]` | `values` leaf values

    - ### Fields inherited from class org.apache.lucene.index.SortedSetDocValues

      `NO_MORE_ORDS`

    - ### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

      `NO_MORE_DOCS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MultiSortedSetDocValues(SortedSetDocValues[] values, int[] docStarts, OrdinalMap mapping, long totalCost)` Creates a new MultiSortedSetDocValues over `values`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `advance(int targetDocID)` Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
    `boolean` | `advanceExact(int targetDocID)` Advance the iterator to exactly `target` and return whether `target` has a value.
    `long` | `cost()` Returns the estimated cost of this `DocIdSetIterator`.
    `int` | `docID()` Returns the following: `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
    `long` | `getValueCount()` Returns the number of unique values.
    `BytesRef` | `lookupOrd(long ord)` Retrieves the value for the specified ordinal.
    `int` | `nextDoc()` Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set. NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
    `long` | `nextOrd()` Returns the next ordinal for the current document.

    - ### Methods inherited from class org.apache.lucene.index.SortedSetDocValues

      `intersect, lookupTerm, termsEnum`

    - ### Methods inherited from class org.apache.lucene.search.DocIdSetIterator

      `all, empty, range, slowAdvance`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### docStarts

          public final int[] docStarts

      docbase for each leaf: parallel with `values`

    - #### values

          public final SortedSetDocValues[] values

      leaf values

    - #### mapping

          public final OrdinalMap mapping

      ordinal map mapping ords from `values` to global ord space

  - ### Constructor Detail

    - #### MultiSortedSetDocValues

          public MultiSortedSetDocValues(SortedSetDocValues[] values,
                                         int[] docStarts,
                                         OrdinalMap mapping,
                                         long totalCost)
                                  throws IOException

      Creates a new MultiSortedSetDocValues over `values`
      Throws:
        `IOException`

  - ### Method Detail

    - #### docID

          public int docID()

      Description copied from class: `DocIdSetIterator`
      Returns the following:
      - `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
      - `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
      - Otherwise it should return the doc ID it is currently on.

      Specified by:
        `docID` in class `DocIdSetIterator`

    - #### nextDoc

          public int nextDoc()
                      throws IOException

      Description copied from class: `DocIdSetIterator`
      Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
      NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
      Specified by:
        `nextDoc` in class `DocIdSetIterator`
      Throws:
        `IOException`

    - #### advance

          public int advance(int targetDocID)
                      throws IOException

      Description copied from class: `DocIdSetIterator`
      Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

      The behavior of this method is undefined when called with `target ≤ current`, or after the iterator has exhausted. Both cases may result in unpredicted behavior.

      When `target > current` it behaves as if written:

           int advance(int target) {
             int doc;
             while ((doc = nextDoc()) < target) {
             }
             return doc;
           }

      Some implementations are considerably more efficient than that.

      NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

      Specified by:
        `advance` in class `DocIdSetIterator`
      Throws:
        `IOException`

    - #### advanceExact

          public boolean advanceExact(int targetDocID)
                               throws IOException

      Advance the iterator to exactly `target` and return whether `target` has a value. `target` must be greater than or equal to the current `doc ID` and must be a valid doc ID, ie. ≥ 0 and < `maxDoc`. After this method returns, `DocIdSetIterator.docID()` returns `target`.
      Throws:
        `IOException`

    - #### nextOrd

          public long nextOrd()
                       throws IOException

      Description copied from class: `SortedSetDocValues`
      Returns the next ordinal for the current document. It is illegal to call this method after `advanceExact(int)` returned `false`.
      Specified by:
        `nextOrd` in class `SortedSetDocValues`
      Returns:
        next ordinal for the document, or `SortedSetDocValues.NO_MORE_ORDS`. ordinals are dense, start at 0, then increment by 1 for the next value in sorted order.
      Throws:
        `IOException`

    - #### lookupOrd

          public BytesRef lookupOrd(long ord)
                             throws IOException

      Description copied from class: `SortedSetDocValues`
      Retrieves the value for the specified ordinal. The returned `BytesRef` may be re-used across calls to lookupOrd so make sure to `copy it` if you want to keep it around.
      Specified by:
        `lookupOrd` in class `SortedSetDocValues`
      Parameters:
        `ord` - ordinal to lookup
      Throws:
        `IOException`
      See Also:
        `SortedSetDocValues.nextOrd()`

    - #### getValueCount

          public long getValueCount()

      Description copied from class: `SortedSetDocValues`
      Returns the number of unique values.
      Specified by:
        `getValueCount` in class `SortedSetDocValues`
      Returns:
        number of unique values in this SortedDocValues. This is also equivalent to one plus the maximum ordinal.

    - #### cost

          public long cost()

      Description copied from class: `DocIdSetIterator`
      Returns the estimated cost of this `DocIdSetIterator`.

      This is generally an upper bound of the number of documents this iterator might match, but may be a rough heuristic, hardcoded value, or otherwise completely inaccurate.

      Specified by:
        `cost` in class `DocIdSetIterator`

Copyright © 2000-2020 Apache Software Foundation. All Rights Reserved.